DocBaseBitSetIterator (Lucene 10.5.0 core API)
Description: declaration: package: org.apache.lucene.util, class: DocBaseBitSetIterator

Package org.apache.lucene.util

# Class DocBaseBitSetIterator

java.lang.Object
org.apache.lucene.search.DocIdSetIterator
org.apache.lucene.search.AbstractDocIdSetIterator
org.apache.lucene.util.DocBaseBitSetIterator

public class DocBaseBitSetIterator extends AbstractDocIdSetIterator
A `DocIdSetIterator` like `BitSetIterator` but has a doc base in order to avoid storing previous 0s.

- ## Field Summary

  ### Fields inherited from class org.apache.lucene.search.AbstractDocIdSetIterator

  `doc`

  ### Fields inherited from class org.apache.lucene.search.DocIdSetIterator

  `NO_MORE_DOCS`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `DocBaseBitSetIterator(FixedBitSet bits, long cost, int docBase)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `int`
  `advance(int target)`
  Advances to the first beyond the current whose document number is greater than or equal to target, and returns the document number itself.
  `long`
  `cost()`
  Returns the estimated cost of this `DocIdSetIterator`.
  `FixedBitSet`
  `getBitSet()`
  Get the `FixedBitSet`.
  `int`
  `getDocBase()`
  Get the docBase.
  `void`
  `intoBitSet(int upTo, FixedBitSet bitSet, int offset)`
  Load doc IDs into a `FixedBitSet`.
  `int`
  `nextDoc()`
  Advances to the next document in the set and returns the doc it is currently on, or `DocIdSetIterator.NO_MORE_DOCS` if there are no more docs in the set.
  NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.

  ### Methods inherited from class org.apache.lucene.search.AbstractDocIdSetIterator

  `docID`

  ### Methods inherited from class org.apache.lucene.search.DocIdSetIterator

  `all, docIDRunEnd, empty, range, slowAdvance`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### DocBaseBitSetIterator

    public DocBaseBitSetIterator(FixedBitSet bits, long cost, int docBase)

- ## Method Details

  - ### getBitSet

    public FixedBitSet getBitSet()
    Get the `FixedBitSet`. A docId will exist in this `DocIdSetIterator` if the bitset contains the (docId - `getDocBase()`)
    Returns:
      the offset docId bitset

  - ### getDocBase

    public int getDocBase()
    Get the docBase. It is guaranteed that docBase is a multiple of 64.
    Returns:
      the docBase

  - ### nextDoc

    public int nextDoc()
    Description copied from class: `DocIdSetIterator`
    Advances to the next document in the set and returns the doc it is currently on, or `DocIdSetIterator.NO_MORE_DOCS` if there are no more docs in the set.
    NOTE: after the iterator has exhausted you should not call this method, as it may result in unpredicted behavior.
    Specified by:
      `nextDoc` in class `DocIdSetIterator`

  - ### advance

    public int advance(int target)
    Description copied from class: `DocIdSetIterator`
    Advances to the first beyond the current whose document number is greater than or equal to target, and returns the document number itself. Exhausts the iterator and returns `DocIdSetIterator.NO_MORE_DOCS` if target is greater than the highest document number in the set.

    The behavior of this method is undefined when called with `target ≤ current` , or after the iterator has exhausted. Both cases may result in unpredicted behavior.

    When `target > current` it behaves as if written:

         int advance(int target) {
           int doc;
           while ((doc = nextDoc()) < target) {
           }
           return doc;
         }

    Some implementations are considerably more efficient than that.

    NOTE: this method may be called with `DocIdSetIterator.NO_MORE_DOCS` for efficiency by some Scorers. If your implementation cannot efficiently determine that it should exhaust, it is recommended that you check for that value in each call to this method.

    Specified by:
      `advance` in class `DocIdSetIterator`

  - ### cost

    public long cost()
    Description copied from class: `DocIdSetIterator`
    Returns the estimated cost of this `DocIdSetIterator`.

    This is generally an upper bound of the number of documents this iterator might match, but may be a rough heuristic, hardcoded value, or otherwise completely inaccurate.

    Specified by:
      `cost` in class `DocIdSetIterator`

  - ### intoBitSet

    public void intoBitSet(int upTo, FixedBitSet bitSet, int offset) throws IOException
    Description copied from class: `DocIdSetIterator`
    Load doc IDs into a `FixedBitSet`. This should behave exactly as if implemented as below, which is the default implementation:

         for (int doc = docID(); doc < upTo; doc = nextDoc()) {
           bitSet.set(doc - offset);
         }

    Note: `offset` must be less than or equal to the `current doc ID`. Behaviour is undefined if this iterator is unpositioned.

    Note: It is important not to clear bits from `bitSet` that may be already set.

    Note: `offset` may be negative.

    Overrides:
      `intoBitSet` in class `DocIdSetIterator`
    Throws:
      `IOException`